# vars:
#  awscli_exe: ""
#  aws_region: ""
#  {"my_stack": {"stack_template": ""}}
#  my_stack_name: ""
#  new_cfn_parameters: {}

- name: change_cfn_parameters | create the CFN change set
  cloudformation:
    create_changeset: yes
    region: '{{ aws_region }}'
    stack_name: '{{ my_stack_name }}'
    state: present
    # copy the template, since we don't have to fiddle with it
    # although watch out because if the template is JSON, ansible will auto-coerce
    # it into a formal dict, which if blindly fed back would be {'AWS-whatever': ''} syntax
    # that leading " " is to keep ansible from *re-coercing* it from the jinja evaluation
    template_body: >-
        {{ (" "+(my_stack.stack_template|to_json))
           if ("dict" == (my_stack.stack_template|type_debug))
           else my_stack.stack_template
        }}
    # but it appears one _does_ have to duplicate the "MasterPoolSize" mod
    # since stack_parameters is the *original* value, not the one from a few lines ago
    template_parameters: >-
      {{ my_stack.stack_parameters | combine(new_cfn_parameters) }}
  register: cf_change

- name: change_cfn_parameters | grab execute-change-set command
  # putting this in a fact makes it easier to debug
  set_fact:
    cf_execute_cs: >-
      {{ cf_change.warnings
      | select("match", ".*aws cloudformation execute-change-set.*")
      | first
      | regex_replace("^.*?aws cloudformation", awscli_exe + " cloudformation")
      }}

- name: change_cfn_parameters | execute the change set
  command: '{{ cf_execute_cs }}'
  environment:
    AWS_DEFAULT_REGION: '{{ aws_region }}'

- name: change_cfn_parameters | clear my cf_ variables
  set_fact:
    cf_change: ~
    cf_execute_cs: ~

- name: change_cfn_parameters | wait for changeset to apply
  command: >-
    {{ awscli_exe }} cloudformation wait stack-update-complete
    --stack-name "{{ my_stack_name }}"
  environment:
    AWS_DEFAULT_REGION: '{{ aws_region }}'
